
#ifndef __GLINE__

#include <stdio.h>
#include "struct.h"
#include <string.h>
#include <errno.h>
#include "errors.h"

extern int errno;

#define GLINE_MAGIC 0xdeadbeef

struct gline {
     int magic;
     struct gline *prev, *next;
     char hostmask[100];
     char reason[100];
     int expire_time;
     int do_delete;
     int is_enabled;
};

extern struct gline *glist;

extern int __init_glines();
extern struct gline *find_gline(char *hm, int exact);
extern struct gline *construct_gline(char *hm, char *reason, int seconds_to_expire);
extern int link_gline(struct gline *q);
extern int expire_glines();

extern void strtolower(char *i);
extern int match(char *hm, char *hn);
extern void broadcast_to_ops(char *fmt,...);

extern void m_gline(struct fd_list *fd, char **av, int ac);

#endif /* !__GLINE__ */
