#ifndef _IRC_PRINTF_H_
#define _IRC_PRINTF_H_

#include <stdio.h>
#include <pthread.h>
#include <stdarg.h>

struct file_struct {
     FILE *sok;			/* file of the type returned by fopen/fdopen */
     pthread_mutex_t mut;	/* mutex guaranteeing exclusive read/write access */
};

typedef struct file_struct FILE2;

#ifndef __GNUC__
#define __attribute__ (args)
#endif

extern int irc_printf(const char *fmt,...) __attribute__((format(printf, 1, 2)));
     extern int irc_fprintf(FILE2 * fd, const char *fmt,...) __attribute__((format(printf, 2, 3)));
     extern int irc_vprintf(const char *fmt, va_list ap);
     extern int irc_vfprintf(FILE2 * fd, const char *fmt, va_list ap);
     extern int irc_fflush(FILE2 * str);

     extern FILE2 *irc_fopen(char *path, char *mode);
     extern FILE2 *irc_fdopen(int fd, char *mode);
     extern int irc_fclose(FILE2 * stream);
     extern int irc_feof(FILE2 * stream);
     extern int irc_fgetc(FILE2 * stream);
     extern char *irc_fgets(char *s, int l, FILE2 * str);
     extern int irc_getchar(void);
     extern char *irc_gets(char *s);
     extern int irc_ungetc(int c, FILE2 * str);

#endif /* !_IRC_PRINTF_H_ */
