#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include "log.h"

/* int open_listen_sok(int port)
   opens a listening socket on port
 */

int open_listen_sok(int port)
{
     int fd, oval;
     struct sockaddr_in la;
     struct hostent *hp;

     fprintf(stderr, "%s:%i: port = %i\n", __PRETTY_FUNCTION__, __LINE__, port);
     if ((hp = gethostbyname("0.0.0.0")) == NULL) {
	  fprintf(stderr, "gethostbyname failed\n");
	  return -1;
     }
     bcopy(hp->h_addr, (char *) &la.sin_addr, hp->h_length);
     la.sin_family = hp->h_addrtype;
     la.sin_port = htons(port);

     printf("la.sin_port=%i\n", ntohs(la.sin_port));

     if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	  perror("socket");
	  return -1;
     }
     oval = 1;
     setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &oval, sizeof(oval));
     if ((bind(fd, (struct sockaddr *) &la, sizeof(la)) < 0)) {
	  perror("bind");
	  return -1;
     }
     listen(fd, 128);
     return fd;
}

/* int accept_connect(int fd, struct sockaddr *la)
   accepts a connection from listening socket fd
 */

int accept_connect(int fd, struct sockaddr *la)
{
     int foo, m;

     m = sizeof(*la);
     if ((foo = accept(fd, la, &m)) < 0) {
	  return -1;
     } {
	  struct linger q;
	  int l;

	  q.l_onoff = 1;
	  q.l_linger = 100;	/* wait 1 second for delivery */
	  setsockopt(fd, SOL_SOCKET, SO_LINGER, &q, sizeof(q));
	  l = 1;
	  setsockopt(fd, SOL_SOCKET, SO_KEEPALIVE, &l, sizeof(l));
     }
     return foo;
}

/* int open_listen_sok2(int port, int ipnum)
   opens a listening socket on ipnum:port
 */

int open_listen_sok_2(int port, int ipnum)
{
     int fd, oval;
     struct sockaddr_in la;
     struct hostent *hp;

     fprintf(stderr, "%s:%i: ipnum = %i, port = %i\n", __PRETTY_FUNCTION__, __LINE__, ipnum, port);
     bcopy((char *) &ipnum, (char *) &la.sin_addr, sizeof(int));

     la.sin_family = hp->h_addrtype;
     la.sin_port = htons(port);

     printf("la.sin_port=%i\n", ntohs(la.sin_port));

     if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	  perror("socket");
	  return -1;
     }
     oval = 1;
     setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &oval, sizeof(oval));
     if ((bind(fd, (struct sockaddr *) &la, sizeof(la)) < 0)) {
	  perror("bind");
	  return open_listen_sok(port);
     }
     listen(fd, 128);
     return fd;
}
