
#ifndef __log_h__
#define __log_h__

#define ERROR(text, exit_val) \
	fprintf(stderr, "%s:%i: in %s: %s\n", __FILE__, __LINE__, __PRETTY_FUNCTION__, text); \
	exit(exit_val);
#define error(a, b) ERROR(a, b)

#ifdef DEBUGALL

#define DEBUGMAIN
#define DEBUGSOCK
#define DEBUGMEM

#endif

/* #if defined(DEBUGMAIN) || defined(DEBUGSOCK) || defined(DEBUGMEM) */

#define log(text) \
	fprintf(stderr, "log message: %s:%i: (from thread %i) in %s: %s\n", __FILE__, \
	__LINE__, pthread_self(), __PRETTY_FUNCTION__, text); \
	fflush(stderr);

#define log2(logfmt, args) \
	{ \
		char tmp[255]; \
		snprintf(tmp, 255, "log message: %s:%i: (from thread %i) in %s: %s\n", \
			__FILE__, __LINE__, pthread_self(), __PRETTY_FUNCTION__, logfmt); \
		fprintf(stderr, tmp, args); \
		fflush(stderr); \
	}

/* #else

   #define log(text)

   #endif */

#endif /* !__log_h__ */
