#include <stdio.h>
#include "irc_printf.h"
#include <pthread.h>
#include "gc.h"
#include "struct.h"

typedef struct msgs {
     struct msgs *prev, *next;
     char name[20];
     int n_uses;
     int bytes_sent;
} msgs;

msgs *m_ptr = NULL;
int is_initialized = 0;

void st_implicit_init()
{
     if (!is_initialized) {
	  m_ptr = gcAlloc(sizeof(msgs));
	  bzero(m_ptr, sizeof(msgs));
	  is_initialized = 1;
     }
}

msgs *
 add_entry(char *name)
{
     msgs *q = gcAlloc(sizeof(msgs));
     msgs *l = m_ptr;

     bzero(q, sizeof(msgs));
     while (l->next)
	  l = l->next;
     q->prev = l;
     l->next = q;
     snprintf(q->name, 20, "%s", name);
     return q;
}

msgs *
 find_entry(char *name)
{
     msgs *q = m_ptr->next;

     while (q) {
	  if (!strcasecmp(q->name, name)) {
	       return q;
	  }
	  q = q->next;
     }

     return add_entry(name);
}

void update_cmd(char *name, char *buf)
{
     msgs *q = find_entry(name);

     q->n_uses++;
     q->bytes_sent += strlen(buf);
}

void __stats_m_reply(struct fd_list *fd)
{
     msgs *l = m_ptr->next;

     while (l) {
	  irc_fprintf(fd->sok, ":%s 212 %s %s %i %i\r\n", server_name, fd->nick, l->name, l->n_uses, l->bytes_sent);
	  l = l->next;
     }
}
