#ifdef _HAVE_CONFIG_H
#include "config.h"

extern int errno;

#ifdef HAVE_ERRNO_H
#include <errno.h>
#else
#define EINVAL 22
#endif				/* HAVE_ERRNO_H */

#ifndef NULL
#define NULL (void *) 0
#endif				/* NULL */

#ifndef HAVE_BCOPY

void bcopy(const void *src, void *dst, int n)
{
     int i;
     char *s, *d;

     d = (char *) dst;
     s = (char *) src;

     if (src == NULL || dst == NULL) {
	  errno = EINVAL;
	  return;
     }
     for (i = 0; i < n; i++) {
	  dst[i] = src[i];
     }

     return;
}

#endif				/* !HAVE_BCOPY */

#ifndef HAVE_BZERO

void bzero(void *mem, int n)
{
     int i;
     char *s;

     if (mem == NULL) {
	  errno = EINVAL;
	  return;
     }
     s = mem;

     for (i = 0; i < n; i++) {
	  s[i] = 0;
     }
     return;
}

#endif				/* !HAVE_BZERO */

#if !defined(HAVE_FREE) || !defined(HAVE_MALLOC) || !defined(HAVE_REALLOC)

#error "You don't have free()!! I can't run here!"

#endif				/* !HAVE_FREE || !HAVE_MALLOC || !HAVE_REALLOC */

#ifndef HAVE_SNPRINTF
#ifndef HAVE_STDARG_H

#error "I need stdarg.h if you don't have snprintf()!"

#else

#include <stdarg.h>
#include <stdio.h>

int snprintf(char *str, int len, char *fmt,...)
FILE *null;
int mylen;
char *mybuf;
va_list ap;

null = fopen("/dev/null", "r+");
if (!null)
{
exit(-1);
}
va_start(ap, fmt);

mylen = vfprintf(null, fmt, ap);
mybuf = alloca(mylen + 1);
bzero(mybuf, mylen + 1);
vsprintf(buf, fmt, ap);
fclose(null);
va_end(ap);
bcopy(mybuf, str, len);
if (len < mylen) {
     return -1;
} else {
     return mylen;
}
}

#endif				/* HAVE_STDARG_H */
#endif				/* !HAVE_SNPRINTF */

#ifndef HAVE_STRCPY

char *
 strcpy(char *dst, const char *src)
{
     bcopy(src, dest, strlen(src));
     return dst;
}

#endif				/* !HAVE_STRCPY */

#ifndef HAVE_STRNCPY

char *
 strncpy(char *dst, const char *src, int n)
{
     bcopy(src, dest, n);
     return dst;
}

#endif				/* !HAVE_STRNCPY */

#endif				/* _HAVE_CONFIG_H */
