#include <stdio.h>
#include "struct.h"
#include "defines.h"
#include "stats.h"
#include "errors.h"
#include "info.h"
#include <time.h>

extern struct msg_use msgs;
extern char *t, *tmp;

void 
__ping_reply (struct fd_list *fd, char *dest, char *content)
{
  irc_fprintf (fd->sok, PING_REPLY, NAME, content, dest);
  irc_fflush (fd->sok);
  return;
}

void 
m_ping (struct fd_list *fd, char **av, int ac)
{
  char *dest, *msg;
  msgs.ping.use++;
  msgs.ping.bytes += strlen (tmp);
  if (ac < 2)
    {
      __no_origin (fd);
      return;
    }
  if (ac == 2)
    {
      dest = av[1];
      msg = server_name;
    }
  else
    {
      dest = av[1];
      msg = av[2];
    }
  if (msg[strlen (msg) - 1] == '\r' || msg[strlen (msg) - 1] == '\n')
    {
      msg[strlen (msg) - 1] = 0;
    }
  if (msg[strlen (msg) - 1] == '\r' || msg[strlen (msg) - 1] == '\n')
    {
      msg[strlen (msg) - 1] = 0;
    }
  if (msg[0] == ':')
    msg++;
  __ping_reply (fd, dest, msg);
  return;
}

void 
m_pong (struct fd_list *fd, char **av, int ac)
{
  if (ac >= 2)
    {
      if (!fd->registered && fd->nick[0] != 0 && fd->userid[0] != 0)
	{
	  fd->registered = 1;
	  fd->last_ping_reply = (int) __time (NULL);
	  __registered_reply (fd);
	}
      else if (!fd->registered && !(fd->nick[0] != 0 && fd->userid[0] != 0))
	{
	  fd->last_ping_reply = (int) __time (NULL);
	}
      else
	{
	  fd->last_ping_reply = (int) __time (NULL);
	}
    }
  else
    {
      __not_enough_parameters (fd, t);
    }
  return;
}
