#include <stdio.h>
#include "struct.h"
#include "stats.h"
#include "channels.h"
#include "user.h"
#include "errors.h"
#include "defines.h"

extern struct msg_use msgs;
extern char *tmp, *t;

void __who_all(struct fd_list *fd)
{
     struct fd_list *users = __head->next;

     while (users != NULL) {
	  if (!users->invisible) {
	       irc_fprintf(fd->sok, RPL_WHOREPLY, server_name, fd->nick, "*", users->userid, users->hostname, server_name,
			   users->nick, (
					     (users->away_set ?
					      (users->oper ?
					       "G*" :
					       "G"
					      ) :
					      (users->oper ?
					       "H*" :
					       "H"
					      )
					     )
			   ), 1, fd->realname);
	  }
	  users = users->next;
     }

     irc_fprintf(fd->sok, RPL_ENDOFWHO, server_name, fd->nick, "*");
     return;
}

void m_who(struct fd_list *fd, char **av, int ac)
{
     char *name;

     msgs.who.use++;
     msgs.who.bytes += strlen(tmp);
     if (ac > 1) {
	  name = av[1];
	  if (name[0] == '#') {
	       __who_channel(fd, name);
	  } else {
	       __who_user(fd, name);
	  }
     } else {
	  __not_enough_parameters(fd, t);
     }
     return;
}
